# Class: Insert

Defined in: | lib/Types/BasicTypes.coffee
Inherits: | Operation

## Overview

A simple insert-type operation.

An insert operation is always positioned between two other insert operations. Internally this is realized as associative lists, whereby each insert operation has a predecessor and a successor. For the sake of efficiency we maintain two lists: - The short-list (abbrev. sl) maintains only the operations that are not deleted - The complete-list (abbrev. cl) maintains all operations

## Direct Known Subclasses

ImmutableObject

## Instance Method Summary

- # (void) applyDelete(o) Private
- # (void) isDeleted() If isDeleted() is true this operation won't be maintained in the sl
- # (void) getDistanceToOrigin() Private The amount of positions that $this operation was moved to the right.
- # (void) update_sl() Private Update the short list TODO (Unused)
- # (void) execute() Private Include this operation in the associative lists.

## Inherited Method Summary

### Methods inherited from Operation

#on #callEvent #setParent #getUid #execute #saveOperation #validateSavedOperations

## Constructor Details

# (void) constructor(uid, prev_cl, next_cl, origin)

### Parameters:

- uid ( `Object` ) — A unique identifier. If uid is undefined, a new uid will be created.
- prev_cl ( `Operation` ) — The predecessor of this operation in the complete-list (cl)
- next_cl ( `Operation` ) — The successor of this operation in the complete-list (cl)

### See also:

- HistoryBuffer.getNextOperationIdentifier

## Instance Method Details

# (void) applyDelete(o) Private

# (void) isDeleted()

If isDeleted() is true this operation won't be maintained in the sl

# (void) getDistanceToOrigin() Private

The amount of positions that $this operation was moved to the right.

# (void) update_sl() Private

Update the short list TODO (Unused)

# (void) execute() Private

Include this operation in the associative lists.

Quickly fuzzy find classes, mixins, methods, file:

- T Open fuzzy finder dialog

Control the navigation frame:

- L Toggle list view
- C Show class list
- I Show mixin list
- F Show file list
- M Show method list
- E Show extras list

You can focus and blur the search input:

- S Focus search input
- Esc Blur search input